// _o
public class ShinkeiSuijaku {
	// J[h̏Ԃ\萔
	final static int STATUS_HIDE = 0;	// ꂽ
	final static int STATUS_OPEN = 1;	// I[v̏
	final static int STATUS_PAIR = 2;	// 

	// J[hԍi[z
	static int[] cards;

	// J[h̏Ԃi[z
	static int[] statuses;

	// I[vJ[hLz
	static int[] memory;


	// J[h̏
	private static void initCards()
	{
		// J[hi[z
		cards = new int[ 52 ];

		// J[hzɊi[AVt
		for ( int i = 0; i < cards.length; i++ )
			cards[ i ] = ( i / 4 ) + 1;

		for ( int i = 0; i < cards.length; ++ i ) {
			// 0`(zcardš-1)̗𔭐
			int rnd = (int)( Math.random() * (double)cards.length );

			// cards[ i ]cards[ rnd ]ւ
			int w = cards[ i ];
			cards[ i ] = cards[ rnd ];
			cards[ rnd ] = w;
		}
	}


	// Ԃ̏
	private static void initStatuses()
	{
		statuses = new int[ 52 ];
		// J[h̏Ԃ"Bꂽ"ɂ
		for ( int i = 0; i < statuses.length; i++ )
			statuses[ i ] = STATUS_HIDE;
	}


	// L̏
	private static void initMemory()
	{
		memory = new int[ 52 ];
		for ( int i = 0; i < memory.length; i++ )
			memory[ i ] = 0;
	}


	// J[h̏o
	private static void outputCards()
	{
		for ( int i = 0; i < cards.length; ++ i ) {
			//
			switch ( statuses[ i ] ) {
				case STATUS_HIDE:
					System.out.print( "*" );
					break;

				case STATUS_OPEN:
				case STATUS_PAIR:
					switch ( cards[ i ] )
					{
						case 10:
							System.out.print( "A" );
							break;
						case 11:
							System.out.print( "J" );
							break;
						case 12:
							System.out.print( "Q" );
							break;
						case 13:
							System.out.print( "K" );
							break;

						default:
							System.out.print( cards[ i ] );
							break;
					}
					break;
			}

			// J[hPRƂɉs
			if ( 0 == ( ( i + 1 ) % 13 ) )
				System.out.println();
		}
		// s
		System.out.println();
	}


	// w肵Ԃ̐߂
	private static int getStatusNumber( int status  )
	{
		int number = 0;

		for ( int i = 0; i < statuses.length; i++ ) {
			if ( statuses[ i ] == status )
				++ number;
		}

		return number;
	}


	// J[hPI[v
	private static int openCard()
	{
		// ꂽJ[h̐擾
		int hidenumber = getStatusNumber( STATUS_HIDE );
		if ( 1 > hidenumber ) return 0;

		// 1`hidenumber̗𔭐
		int rnd = (int)( Math.random() * (double)hidenumber ) + 1;

		// ꂽJ[hrndԖڂ̃J[hI[v
		int cardnum = 0;
		for ( int i = 0; i < statuses.length; i++ ) {
			if ( STATUS_HIDE == statuses[ i ] ) {
				--rnd;			
				if ( 0 == rnd ) {
					// Ԃ"I[v̏"ɕύX
					statuses[ i ] = STATUS_OPEN;
					// J[hԍ
					cardnum = cards[ i ];
					//Lo^
					memory[ i ] = cardnum;
					break;
				}
			}
		}

		// I[vJ[hԍ߂
		return cardnum;
	}


	// LJ[hԍŉBĂJ[hI[v
	private static boolean openMemoryCard( int cardnum )
	{
		for ( int i = 0; i < statuses.length; i++ ) {
			if ( STATUS_HIDE == statuses[ i ] ) {
				if ( cardnum == memory[ i ] ) {
					// Ԃ"I[v̏"ɕύX
					statuses[ i ] = STATUS_OPEN;
					return true;
				}
			}
		}

		return false;
	}


	// "I[v"̂Q̃J[hԍ𔻒	
	private static boolean isPair()
	{
		int number, cardnum;

		number = 0;
		cardnum = 0;
		for ( int i = 0; i < statuses.length; i++ ) {
			if ( STATUS_OPEN == statuses[ i ] ) {
				++ number;
				if ( 1 == number ) {
					// 1
					cardnum = cards[ i ]; 
				}
				else {
					// 2
					if ( cardnum == cards[ i ] ) {
						return true;
					}
					break;
				}
			}
		}

		return false;
	}


	// Ԃ̕ύXiԁVԁj
	private static void replaceStatus( int oldStatus, int newStatus )
	{
		for ( int i = 0; i < statuses.length; i++ ) {
			if ( oldStatus == statuses[ i ] )
				statuses[ i ] = newStatus;
		}
	}
	

	// C
	public static void main( String[] args ) {
		// J[h̏
		initCards();

		// Ԃ̏
		initStatuses();

		// L̏
		initMemory();

		// _o{
		// [v쐬([v𔲂Ȃ)
		for ( int turn = 1; ; ++ turn ) {
			// ^[ԍ̏o
			System.out.println( "^[:" + turn );

			// J[ho(I[vȌ)
			outputCards();

			// J[h_ɂPI[v
			int cardnum1 = openCard();

			// LĂJ[h΂̃J[hI[v
			if ( !openMemoryCard( cardnum1 ) ) {
				// J[h_ɂPI[v
				int cardnum2 = openCard();
			}
			else {
				System.out.println( "LJ[hI[vI" );
			}

			// J[ho(I[v̏)
			outputCards();

			// I[vĂJ[hyAǂ
			if ( isPair() )
				replaceStatus( STATUS_OPEN, STATUS_PAIR );
			else
				replaceStatus( STATUS_OPEN, STATUS_HIDE );

			// SăyAɂȂ烋[v𔲂
			if ( 52 == getStatusNumber( STATUS_PAIR ) )
				break;
		}

		// J[h̍ŏIʂo
		System.out.println( "ŏI" );
		outputCards();
	}
}
